%%%%% External functions used in this script %%%%%
% send_API_2.m --> sends request to gather frequency readings
% rec_API_2.m --> receives freuency readings from cap-sensor nodes
% send_US_req.m --> sends request for Ultrasound sensor's readings
clear all;
close all;
clc;
%fclose(instrfind);

minutes_of_run = 1;    %each sub-run
hours = 6;              %total run

serialPort = 'COM4';
s = serial(serialPort);
set(s,'BaudRate',9600);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

data_received = zeros(200000,1);

fopen(s);

start_time = clock;
flushinput(s);
flushoutput(s);

data_index = 1 ; %array index to store US/cap sensor values
i = 1;
pause(1);
end_at = 60*minutes_of_run;
j=0;

while j < hours
t0 = clock;
    
while etime(clock, t0) < end_at
        
    if (s.BytesAvailable > 16)
        
        
        [address, total_clocks_during_measurement, total_input_periods] = rec_API_2b(s);  
     
           if (total_clocks_during_measurement > 0)
            
            data_received(i) =(double(total_clocks_during_measurement)/64.0)*(5.0/65536.0);   
                 
            disp(data_received(i));        
            
            i=i+1;
           
           end
     end
end

t0=clock;

j=j+1;

data=nonzeros(data_received);
save(sprintf('frontend2_%s.mat', datestr(now,'mm-dd HH-MM')),'data');

end

data=nonzeros(data_received);
save(sprintf('frontend2_%s.mat', datestr(now,'mm-dd HH-MM')),'data');

figure(1);
plot(data);
ylabel('voltage [V]');
title('sensitivity');
grid on;

xticks(1:(length(data)/6):length(data)+1);
xlabel('Distance[m]');
xticklabels({'0.25','0.50','0.75','1.00','1.50','2.00'});
saveas(gcf,sprintf('frontend2_FINAL_25cmto200cm_NOPERSON_%s.png', datestr(now,'mm-dd HH-MM')));






