function [address, total_clocks_during_measurement, total_input_periods] = rec_API_2b(s) % s is the serial PORT object

START_BYTE = uint8(hex2dec('7E'));
ESCAPE = uint8(hex2dec('7D'));
XON = uint8(hex2dec('11'));
XOFF = uint8(hex2dec('13'));
API_ID_INDEX = 3;

%serialPort = '/dev/ttyACM0';        % define COM port #

% serialPort = 'COM5';               % define COM port #
% s = serial(serialPort);
% set(s,'BaudRate',9600);

% fopen(s);
   
pos_ = 0;

escape_ = false;

checksumTotal_ = 0;
data_frame_pos_ = 1;
checksum_OK = 0;

incoming_data_frame = []; %declaring an empty variable to check data reception

j = 0;
error = 0;
while(s.BytesAvailable > 0)
    b = fread(s, 1, 'uint8');
    if (pos_ > 0 && b == ESCAPE)
        if(s.BytesAvailable > 0)
            b = fread(s, 1, 'uint8');
            actual_b = bitxor(uint8(b), uint8(hex2dec('20')));            
        end
    else
        actual_b = b;
    end
    
    %disp(dec2hex(actual_b));
        
    if (pos_ >= API_ID_INDEX)
        checksumTotal_ = checksumTotal_ + actual_b;  
    end
    
    switch (pos_)
        case 0
            if (actual_b ~= START_BYTE)
                error = 1;
                disp('START BYTE ERROR');
                disp(actual_b);
                break;
            end
            pos_ = pos_ + 1;
        case 1
            lengthMSB = actual_b;
            pos_ = pos_ + 1;
        case 2
            lengthLSB = actual_b;
            pos_ = pos_ + 1;
            temp_pkt_length = PacketLength(lengthMSB, lengthLSB);
            %disp(temp_pkt_length);
        case 3
            API_ID = actual_b;
            pos_ = pos_ + 1;
        otherwise
            
            %using a seperate variable for packet length 
            %so it can be reset after each packet
            if (pos_ == (temp_pkt_length + 3) )
                %disp(temp_pkt_length);
                
                if (bitand(checksumTotal_, 255) == 255 )
                    checksum_OK = 1;
                    %disp('new packet available');
                    packet_available_signal = 1;
                else 
                    checksum_OK = 0;   
                    disp('checksum failed');
                end
                
                data_frame_length = (pos_ - 4);
                
                pos_ = 0;            % pos_ is used to match with 
                                     % Arduino lib, not used for indexing
                data_frame_pos_ = 1; % set to 1 because matlab arrary
                                     % indexing starts with 1.
                                     
                temp_pkt_length = 0;
                
                break; %finished acquiring one packet
                
            else
                %disp(actual_b);
                incoming_data_frame(data_frame_pos_) = actual_b;
                pos_ = pos_ + 1 ;
                data_frame_pos_ = data_frame_pos_ + 1;
            end
            
    end
    j=j+1; %just for check, not used anywhere
    
%pause(0.01);    
end


if (~isempty(incoming_data_frame) && error == 0)
    a3 = incoming_data_frame(8);
    a2 = incoming_data_frame(7);
    a1 = incoming_data_frame(6);
    a = incoming_data_frame(5);
    
    total_clocks_during_measurement = typecast( uint8([a a1 a2 a3]), 'uint32');
    %display(total_clocks_during_measurement);
    
    b3 = incoming_data_frame(12);
    b2 = incoming_data_frame(11);
    b1 = incoming_data_frame(10);
    b = incoming_data_frame(9);
    
    total_input_periods = typecast( uint8([b b1 b2 b3]), 'uint32');
    %display(total_input_periods);
    
    %c3 = incoming_data_frame(16);
    %c2 = incoming_data_frame(15);
    %c1 = incoming_data_frame(14);
    %c = incoming_data_frame(13);
    
    %RX_pkt_counter = typecast( uint8([c c1 c2 c3]), 'uint32');
    %display(RX_pkt_counter);
    
    address = horzcat(dec2hex(incoming_data_frame(1)),dec2hex(incoming_data_frame(2)));
    %display(address); 
    return; 
    
else
    display('missed sample');   
    address = 'E';
    total_clocks_during_measurement = 0;
    total_input_periods = 0;
    RX_pkt_counter = 0;
    return;
end



% fclose(s);

function pkt_length = PacketLength(lengthMSB, lengthLSB)
pkt_length = bitor(bitshift(uint16(lengthMSB),8),uint16(lengthLSB));
end

% function int_to_float = fourcell2num(a3,a2,a1,a)
% 
%     first_comb = bitor(bitshift(a3,24),bitshift(a2,16));
%     sec_comb = bitor(bitshift(a1,8),a);
%     int_to_float = double(bitor(first_comb, sec_comb));
%     %final = int_to_float/1000;
%     
% end

end