function send_API_2(s, TX_pkt_count)

%Request Packet XBee

START_BYTE = uint8(hex2dec('7E'));
ESCAPE = uint8(hex2dec('7D'));
XON = uint8(hex2dec('11'));
XOFF = uint8(hex2dec('13'));
API_ID = uint8(hex2dec('01'));
frameID = uint8(hex2dec('00'));
addr = ('FFFF'); % for broadcast
options = uint8(hex2dec('01'));
payload = uint8('1');

%global START_BYTE ESCAPE XON XOFF s

% In current implementation the acknwledgement is disabled so 
% no in parameters 'options' and 'Frame ID' options are not
% provided.
% function XBee_Tx16Request()

counter = uint32(TX_pkt_count);
TX_counter = typecast(counter, 'uint8');

TX_16_API_LENGTH = 3 + 1 + 2 + 4;

pkt_length = typecast(uint16(TX_16_API_LENGTH), 'uint8');

dest_ADDR = typecast(uint16(hex2dec(addr)), 'uint8');

% At the moment we are just sending fixed number 
% of bytes --- might need to be adjusted in future

data_frame = [API_ID frameID dest_ADDR(2) dest_ADDR(1) options payload TX_counter];

check_sum  = uint8(255 - bitand(255, sum(data_frame)));



sendByte(START_BYTE, 0, s);
sendByte(pkt_length(2), 1, s);
sendByte(pkt_length(1), 1, s);
sendByte(API_ID, 1, s);
sendByte(frameID, 1, s);
sendByte(dest_ADDR(2), 1, s);
sendByte(dest_ADDR(1), 1, s);
sendByte(options, 1, s);
sendByte(payload, 1, s);
sendByte(TX_counter(1), 1, s);
sendByte(TX_counter(2), 1, s);
sendByte(TX_counter(3), 1, s);
sendByte(TX_counter(4), 1, s);

sendByte(check_sum, 1, s);

function sendByte(byte_to_send, escape, s)

    START_BYTE = uint8(hex2dec('7E'));
    ESCAPE = uint8(hex2dec('7D'));
    XON = uint8(hex2dec('11'));
    XOFF = uint8(hex2dec('13'));

    b = uint8(byte_to_send);
    if (escape && (b == START_BYTE || b == ESCAPE || b == XON || b == XOFF))
        fwrite(s, ESCAPE);
        fwrite(s, bitxor(uint8(b), uint8(hex2dec('20'))));
    else
        fwrite(s, b);
    end

end

end
