/*
 * GccApplication4.c
 *
 * Created: 11/22/2017 12:01:25 PM
 * Author : d030721
 */ 

// this code sets up counter1 A output at 25% and B output at 75%
// using ICR1 as top (16bit), Fast PWM.
#define F_CPU  16000000UL

#include <stdlib.h>
#include <util/delay.h>

#include <stdint.h>
#include <avr/interrupt.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include "USART.h"
#include "XBEE.h"
#include "XBEE_reception.h"

// Constants
//



// Serial port setup
#define BAUDRATE 9600
#define BAUD_PRESCALLER (((F_CPU / (BAUDRATE * 16UL))) - 1)

// Server protocol
#define SERVER_REQUEST_OFFSET 8
#define SERVER_REQUEST_START_MEASUREMENT 49
#define SERVER_ADDRESS 0xABCD

// Local variables
//
struct payload_s {
	uint32_t total_clocks_during_measurement;
	uint32_t total_input_periods;
} payload;

uint8_t *TX_payload = &payload;
uint32_t total_clocks_during_measurement = 0;
uint32_t total_input_periods = 0;
//float input_signal_frequency = 0.0;




const int sinewave_length=20;
volatile uint8_t end_isr  ;
volatile uint16_t sample;
volatile uint16_t sample;
 char from_slave;
const uint8_t sinewave_data[] PROGMEM = {20,23,26,29,32,34,36,38,39,40,40,40,39,38,36,34,32,29,26,23,20,17,14,11,8,6,4,2,1,0,0,0,1,2,4,6,8,11,14,17};
uint32_t total;
//uint8_t LowBit;
//uint8_t HighBit;
//const uint8_t sinewave_data[] PROGMEM = {20, 26, 32, 36, 39, 40, 39, 36, 32, 26, 20, 14, 8, 4, 1, 0, 1, 4, 8, 14};


ISR(TIMER0_COMPA_vect) {
	if (sample >= sinewave_length) {
		sample = -1;
	}
	else {
		OCR1A = pgm_read_byte(&sinewave_data[sample]);
	}
++sample; 
//end_isr=1;
}




void setPrescaler(uint8_t prescaler)
{
	uint8_t mask = 0XF8;
	ADCSRA &=mask;
	ADCSRA|=prescaler;

}
void adc_init()
{
	setPrescaler(4);
	ADMUX |= (1<<REFS0);
	ADMUX &= ~(1<<REFS1);
	ADCSRA |= (1<<ADEN);                //Power up the ADC
}


void adc_start()
{
	ADCSRA |= (1<<ADSC);   // star convertion
}


int main(void)
{
	DDRB |= (1 << DDB1)|(1 << DDB2);
	// PB1 and PB2 is now an output
	
	ICR1 = 40;
	// set TOP to 16bit
	
	OCR1A = pgm_read_byte(&sinewave_data[0]);;
	// set PWM for 25% duty cycle @ 16bit
	
	TCCR1A |= (1 << COM1A1)|(1 << COM1B1);
	// set none-inverting mode
	
	TCCR1A |= (1 << WGM11);
	TCCR1B |= (1 << WGM12)|(1 << WGM13);
	// set Fast PWM mode using ICR1 as TOP
	
	TCCR1B |= (1 << CS10);
	// START the timer with no prescaler
	
	//setting TIMER0 for updating the values for PWM period

	// Set up Timer 0 to send a sample every interrupt.
	cli();   // disable interrupts
	// Set CTC mode (Section 15.9.2 Clear Timer on Compare Match)
	// WGM = 0b0100, TOP = OCR1A, Update 0CR1A Immediate (Table 15-4)
	// Have to set OCR1A *after*, otherwise it gets reset to 0!
	TCCR0A = 0;
	TCCR0B = 0;
	
	TCCR0B |= (1 << WGM02);
	TCCR0A |= ((1 << WGM01) | (1 << WGM00));
	
	// No prescaler, CS = 0b001 (Table 15-5)
	TCCR0B = (TCCR0B & ~(_BV(CS02) | _BV(CS01))) | _BV(CS00);
	// Set the compare register (OCR1A).
	// OCR1A is a 16-bit register, so we have to do this with
	// interrupts disabled to be safe.
	OCR0A = 10;//F_CPU / SAMPLE_RATE;    // 16e6 / 8000 = 2000
	// Enable interrupt when TCNT1 == OCR1A (p.136)
	TIMSK0 |= _BV(OCIE0A);
	
	sample = 0;
	sei();  // enable interrupts
	adc_init();
	XbeeUSART_init();
	adc_start(); //start the first conversion and ignore it 
	while(ADCSRA & (1<<ADSC));
	while (1)
	{
		//_delay_ms(10);
		//sum all measurement 
		total = 0;
		for(int i=0;i<4096;i++)
		{	
			
			adc_start();
			while(ADCSRA & (1<<ADSC));
			total+=ADC;
		}
		
		payload.total_clocks_during_measurement = total;//total_clocks_during_measurement;
		payload.total_input_periods = 1234;//total_input_periods; THIS IS DUMMY
		
		XBee_TX_Request(SERVER_ADDRESS, TX_payload, sizeof(struct payload_s));
		
		// we have a working Fast PWM
	}
}